package eu.ruekov.ruakij.LinkedBeaconTeleporters.listener;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.customPlayerMoveEvent.CustomPlayerMoveEvent;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.customPlayerMoveEvent.CustomPlayerMoveEventListener;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter.LinkedBeaconTeleporter;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter.LinkedBeaconTeleporterBlock;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter.LinkedBeaconTeleporterManager;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class OnCustomPlayerMove implements CustomPlayerMoveEventListener {

    static HashMap<UUID, LinkedBeaconTeleporterBlock> playerBeaconLocation = new HashMap<>();

    @Override
    public void tick(CustomPlayerMoveEvent e) {
    }

    @Override
    public void locationChange(CustomPlayerMoveEvent e) {

        Player p = e.player();
        UUID uuid = p.getUniqueId();

        // If player found in ignoreList, check if he stepped out of the Beacon-light
        if(playerBeaconLocation.containsKey(uuid)) {
            LinkedBeaconTeleporterBlock lbtBlock = playerBeaconLocation.get(uuid);
            Location lbtBlockLoc = lbtBlock.block().getLocation();
            Location pLoc = p.getLocation();
            if(lbtBlockLoc.getBlockX() != pLoc.getBlockX() || lbtBlockLoc.getBlockZ() != pLoc.getBlockZ()){
                playerBeaconLocation.remove(uuid);
            }
            else
                // Player still on beacon, ignore
                return;
        }

        // Check if player is on-top of a beacon
        Block block = Function.searchForMaterial(
                p.getLocation().add(0, -1, 0),
                new Vector(0, -1, 0),
                Material.BEACON,
                Function.transparentMaterials
        );

        // Skip if not found
        if(block == null) return;

        // TODO: Check if beacon is active

        // Check if beacon is a LinkedBeaconTeleporter
        LinkedBeaconTeleporterBlock lbtBlock = LinkedBeaconTeleporterManager.getLbtBlockFromLocation(block.getLocation());

        // Ignore if not found
        if(lbtBlock == null) return;

        // Check if player should be ignored on this LinkedBeaconTeleporter
        if(playerBeaconLocation.get(uuid) != null && playerBeaconLocation.get(uuid) == lbtBlock) return;

        // Get first partner thats not our current-block
        LinkedBeaconTeleporterBlock lbtBlockPartner = null;
        for(LinkedBeaconTeleporter lbtBlockTmp: lbtBlock.linkedBeaconTeleporters()){
            if(lbtBlockTmp != lbtBlock){
                lbtBlockPartner = (LinkedBeaconTeleporterBlock)lbtBlockTmp;
                break;
            }
        }
        if(lbtBlockPartner == null){
            // No other partner
            p.sendMessage("§cNo linked beacon found with id §7"+ lbtBlock.teleporterId());

            // Set player as ignored on this LinkedBeaconTeleporter (so he wont trigger the checks again)
            playerBeaconLocation.put(uuid, lbtBlock);
        }
        else{
            // TODO: Check if beacon is active

            // Get safe-location on top of other beacon
            Block safeBlock = Function.searchForMaterial(
                    lbtBlockPartner.block().getLocation().add(0, 1, 0),
                    new Vector(0, 1, 0),
                    Material.AIR,
                    Function.transparentMaterials
            );

            if(safeBlock == null){
                // No safe location found
                p.sendMessage("§cNo safe-location found at target teleporter");
                return;
            }
            // TODO: Check if there is enough space for a player

            // Set player as ignored on target-LinkedBeaconTeleporter (so he wont trigger the teleport again)
            playerBeaconLocation.put(uuid, lbtBlockPartner);

            // Teleport
            e.player().teleport(
                    safeBlock.getLocation().add(0.5, 0, 0.5)
            );
        }
    }
}
